package com.zcloud.modules.kangzai.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.zcloud.common.utils.PageUtils;
import com.zcloud.modules.kangzai.dao.BusRiverStructuresPointDao;
import com.zcloud.modules.kangzai.entity.BusRiverStructuresPointEntity;
import com.zcloud.modules.kangzai.service.BusRiverStructuresPointService;
import org.springframework.core.io.ClassPathResource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.io.InputStream;
import java.util.List;
import java.util.Map;

/**
 * @Author fangjiakai
 * @Desc (BusRiverStructuresPoint)表服务实现类
 * @Date 2025-06-10 16:25:26
 */
@Service("busRiverStructuresPointService")
public class BusRiverStructuresPointServiceImpl extends ServiceImpl<BusRiverStructuresPointDao, BusRiverStructuresPointEntity> implements BusRiverStructuresPointService {

    @Override
    public BusRiverStructuresPointEntity queryByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusRiverStructuresPointEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectOne(queryWrapper);
    }

    @Override
    public List<BusRiverStructuresPointEntity> queryListByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusRiverStructuresPointEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectList(queryWrapper);
    }

    @Override
    public PageUtils listPage(Map<String, Object> params) {
        Page<Map<String, Object>> page = new Page<>(Integer.parseInt(params.get("curPage").toString()), Integer.parseInt(params.get("limit").toString()));
        params.put("isDelete", 0);
        IPage<BusRiverStructuresPointEntity> ipage = baseMapper.listPage(page, params);
        return new PageUtils(ipage);
    }


    @Override
    public void delete(Long riverStructuresPointId, String userId) {
        UpdateWrapper<BusRiverStructuresPointEntity> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("river_structures_point_id", riverStructuresPointId);

        BusRiverStructuresPointEntity busRiverStructuresPoint = new BusRiverStructuresPointEntity();

        this.update(busRiverStructuresPoint, updateWrapper);
    }
}
